#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <cwb/cl.h>
#include <stdio.h>

#ifdef __cplusplus
}
#endif


static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(name, arg)
char *name;
int arg;
{
    errno = 0;
    switch (*name) {
    case 'A':
	if (strEQ(name, "ATTAT_FLOAT"))
#ifdef ATTAT_FLOAT
	    return ATTAT_FLOAT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTAT_INT"))
#ifdef ATTAT_INT
	    return ATTAT_INT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTAT_NONE"))
#ifdef ATTAT_NONE
	    return ATTAT_NONE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTAT_PAREF"))
#ifdef ATTAT_PAREF
	    return ATTAT_PAREF;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTAT_POS"))
#ifdef ATTAT_POS
	    return ATTAT_POS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTAT_STRING"))
#ifdef ATTAT_STRING
	    return ATTAT_STRING;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATTAT_VAR"))
#ifdef ATTAT_VAR
	    return ATTAT_VAR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATT_ALIGN"))
#ifdef ATT_ALIGN
	    return ATT_ALIGN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATT_ALL"))
#ifdef ATT_ALL
	    return ATT_ALL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATT_DYN"))
#ifdef ATT_DYN
	    return ATT_DYN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATT_NONE"))
#ifdef ATT_NONE
	    return ATT_NONE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATT_POS"))
#ifdef ATT_POS
	    return ATT_POS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATT_REAL"))
#ifdef ATT_REAL
	    return ATT_REAL;
#else
	    goto not_there;
#endif
	if (strEQ(name, "ATT_STRUC"))
#ifdef ATT_STRUC
	    return ATT_STRUC;
#else
	    goto not_there;
#endif
	break;
    case 'B':
	break;
    case 'C':
	if (strEQ(name, "CDA_EALIGN"))
#ifdef CDA_EALIGN
	    return CDA_EALIGN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_EARGS"))
#ifdef CDA_EARGS
	    return CDA_EARGS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_EATTTYPE"))
#ifdef CDA_EATTTYPE
	    return CDA_EATTTYPE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_EBADREGEX"))
#ifdef CDA_EBADREGEX
	    return CDA_EBADREGEX;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_EIDORNG"))
#ifdef CDA_EIDORNG
	    return CDA_EIDORNG;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_EIDXORNG"))
#ifdef CDA_EIDXORNG
	    return CDA_EIDXORNG;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_ENODATA"))
#ifdef CDA_ENODATA
	    return CDA_ENODATA;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_ENOMEM"))
#ifdef CDA_ENOMEM
	    return CDA_ENOMEM;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_ENOSTRING"))
#ifdef CDA_ENOSTRING
	    return CDA_ENOSTRING;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_ENULLATT"))
#ifdef CDA_ENULLATT
	    return CDA_ENULLATT;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_ENYI"))
#ifdef CDA_ENYI
	    return CDA_ENYI;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_EOTHER"))
#ifdef CDA_EOTHER
	    return CDA_EOTHER;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_EPATTERN"))
#ifdef CDA_EPATTERN
	    return CDA_EPATTERN;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_EPOSORNG"))
#ifdef CDA_EPOSORNG
	    return CDA_EPOSORNG;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_EREMOTE"))
#ifdef CDA_EREMOTE
	    return CDA_EREMOTE;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_ESTRUC"))
#ifdef CDA_ESTRUC
	    return CDA_ESTRUC;
#else
	    goto not_there;
#endif
	if (strEQ(name, "CDA_OK"))
#ifdef CDA_OK
	    return CDA_OK;
#else
	    goto not_there;
#endif
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	break;
    case 'G':
	break;
    case 'H':
	break;
    case 'I':
	if (strEQ(name, "IGNORE_CASE"))	/* regexp flags */
#ifdef IGNORE_CASE
	  return IGNORE_CASE;
#else
	  goto not_there;
#endif
	if (strEQ(name, "IGNORE_DIAC"))	
#ifdef IGNORE_DIAC
	  return IGNORE_DIAC;
#else
	  goto not_there;
#endif
	if (strEQ(name, "IGNORE_REGEX"))
#ifdef IGNORE_REGEX
	  return IGNORE_REGEX;
#else
	  goto not_there;
#endif
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	break;
    case 'O':
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	break;
    case 'S':
	break;
    case 'T':
	break;
    case 'U':
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    case 'a':
	break;
    case 'b':
	break;
    case 'c':
	break;
    case 'd':
      break;
    case 'e':
	break;
    case 'f':
	break;
    case 'g':
	break;
    case 'h':
	break;
    case 'i':
	break;
    case 'j':
	break;
    case 'k':
	break;
    case 'l':
	break;
    case 'm':
	break;
    case 'n':
	break;
    case 'o':
	break;
    case 'p':
	break;
    case 'q':
	break;
    case 'r':
	break;
    case 's':
	break;
    case 't':
	break;
    case 'u':
	break;
    case 'v':
	break;
    case 'w':
	break;
    case 'x':
	break;
    case 'y':
	break;
    case 'z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


MODULE = CL		PACKAGE = CL		

PROTOTYPES: ENABLE

double
constant(name,arg)
	char *		name
	int		arg


void
cl_error(message)
	char *	message

char *
cl_error_string(error_no)
	int	error_no


Corpus *
cl_new_corpus(registry_dir, registry_name)
        char *	registry_dir
        char *	registry_name

int
cl_delete_corpus(corpus)
	Corpus *	corpus

char *
cl_standard_registry()


void
cl_set_debug_level(level)
	int	level

void
cl_set_memory_limit(megabytes)
	int	megabytes

char *
cl_make_set(s, split)
	char *	s
	int	split
      PREINIT:
	char *set;
      PPCODE:
	set = cl_make_set(s, split);
	if (set != NULL) {
	  XPUSHs(sv_2mortal(newSVpv(set, 0)));  /* create Perl string (let Perl compute length) */
	  free(set);  /* <set> was allocated by cl_make_set, so free it again */
	}	
	else {
	  XSRETURN_UNDEF;  /* return undefined value */
	}

int
cl_set_intersection(s1, s2)
	char *	s1
	char *	s2
      PREINIT:
	static char result[CL_DYN_STRING_SIZE];  /* static buffer for results string */
	int ok;
      PPCODE:
	ok = cl_set_intersection(result, s1, s2);
	if (ok) {
	  XPUSHs(sv_2mortal(newSVpv(result, 0)));  /* create Perl string (let Perl compute length) */
	}
	else {
	  XSRETURN_UNDEF;  /* return undefined value */
	}

int
cl_set_size(s)
	char *	s

Attribute *
cl_new_attribute(corpus, attribute_name, type)
	Corpus *	corpus
	char *	attribute_name
	int	type

int
cl_delete_attribute(attribute)
	Attribute *	attribute

int
cl_sequence_compressed(attribute)
	Attribute *	attribute

int
cl_index_compressed(attribute)
	Attribute *	attribute

PositionStream
cl_new_stream(attribute, id)
	Attribute *	attribute
	int	id

int
cl_delete_stream(ps)
	PositionStream *	ps

int
cl_read_stream(ps, buffer, buffer_size)
	PositionStream	ps
	int *	buffer
	int	buffer_size

char *
cl_id2str(attribute, id)
	Attribute *	attribute
	int	id

int
cl_str2id(attribute, id_string)
	Attribute *	attribute
	char *	id_string

int
cl_id2strlen(attribute, id)
	Attribute *	attribute
	int	id

int
cl_sort2id(attribute, sort_index_position)
	Attribute *	attribute
	int	sort_index_position

int
cl_id2sort(attribute, id)
	Attribute *	attribute
	int	id

int
cl_max_cpos(attribute)
	Attribute *	attribute

int
cl_max_id(attribute)
	Attribute *	attribute

int
cl_id2freq(attribute, id)
	Attribute *	attribute
	int	id

int *
cl_id2cpos(attribute, id, freq)
	Attribute *	attribute
	int	id
	int *	freq

int
cl_cpos2id(attribute, position)
	Attribute *	attribute
	int	position

char *
cl_cpos2str(attribute, position)
	Attribute *	attribute
	int	position

# returns list of IDs -> we want to push the IDs on the return stack 
void
cl_regex2id(attribute, pattern, canonicalize)
	Attribute *	attribute
	char *	pattern
	int	canonicalize
      PREINIT:
	int number_of_matches = 0;
        int *idlist;
        int i;
      PPCODE:
        idlist = cl_regex2id(attribute, pattern, canonicalize, &number_of_matches);
        if (idlist != NULL) {
	  EXTEND(sp, number_of_matches); /* push IDs on result stack */
	  for (i=0; i < number_of_matches; i++)
	    PUSHs(sv_2mortal(newSViv(idlist[i])));
	  free(idlist);
	}
        /* else return empty list */ 

# here we need to handle a list as argument
int
cl_idlist2freq(attribute, ...)
      Attribute *	attribute
      PREINIT:
        int i, size;			/* list counter */
        int *list;
      CODE:
	size = items - 1;
        if (size > 0) {
	  list = malloc(size * sizeof(int)); /* convert argument list to list of integer IDs */
	  if (!list) {
	    fprintf(stderr, "CL::cl_idlist2freq: Can't allocate temporary array.\n");
	    exit(1);
	  }
	  for (i = 0; i < size; i++) 
	    list[i] = (int) SvIV(ST(i+1));
	  RETVAL = cl_idlist2freq(attribute, list, size);
	  free(list);
	}
        else {
	  RETVAL = 0;
	}
      OUTPUT:
	RETVAL

# finally we get everything in one function:
#  - scalar arguments
#  - a list argument
#  - return value is a list
void
cl_idlist2cpos(attribute, sort, ...)
	Attribute *	attribute
	int             sort
      PREINIT:
        int i, idlist_size, size;
        int *idlist, *list;
      PPCODE:
	idlist_size = items - 2;
        if (idlist_size > 0) {
	  idlist = malloc(idlist_size * sizeof(int)); /* convert argument list to list of integer IDs */
	  if (!idlist) {
	    fprintf(stderr, "CL::cl_idlist2cpos: Can't allocate temporary array.\n");
	    exit(1);
	  }
	  for (i = 0; i < idlist_size; i++) 
	    idlist[i] = (int) SvIV(ST(i+2));
	  list = cl_idlist2cpos(attribute, idlist, idlist_size, sort, &size);
	  free(idlist);
	  if (list) {
	    EXTEND(sp, size);
	    for (i=0; i < size; i++)
	      PUSHs(sv_2mortal(newSViv(list[i])));
	    free(list);
	  }
	}
        /* else return empty list */




int
cl_struc_values(attribute)
	Attribute *	attribute

int
cl_max_struc(attribute)
	Attribute *	attribute

char *
cl_cpos2struc2str(attribute, position)
	Attribute *	attribute
	int	position

char *
cl_struc2str(attribute, struc_num)
	Attribute *	attribute
	int	struc_num

int
cl_cpos2struc(attribute, position)
	Attribute *	attribute
	int	position

int
cl_struc2cpos(attribute, struc_num)
	Attribute *	attribute
	int	struc_num
      PREINIT:
	int struc_start = -1;
	int struc_end = -1;
      PPCODE:
	if (cl_struc2cpos(attribute, struc_num, &struc_start, &struc_end)) {
	  EXTEND(sp, 2);  /* returns 2 scalar values */
	  PUSHs(sv_2mortal(newSViv(struc_start)));
	  PUSHs(sv_2mortal(newSViv(struc_end)));
	}	
	/* else return empty list */
	  
int
cl_cpos2struc2cpos(attribute, cpos)
	Attribute *	attribute
	int	cpos
      PREINIT:
	int struc_start = -1;
	int struc_end = -1;
      PPCODE:
	if (cl_cpos2struc2cpos(attribute, cpos, &struc_start, &struc_end)) {
	  EXTEND(sp, 2);  /* returns 2 scalar values */
	  PUSHs(sv_2mortal(newSViv(struc_start)));
	  PUSHs(sv_2mortal(newSViv(struc_end)));
	}	
	/* else return empty list */
	  



int
cl_has_extended_alignment(attribute)
	Attribute *	attribute

int
cl_max_alg(attribute)
	Attribute *	attribute

int
cl_cpos2alg(attribute, cpos) 
	Attribute *	attribute
	int 	cpos

int
cl_alg2cpos(attribute, alg_num)
	Attribute *	attribute
	int	alg_num
      PREINIT:
	int source_start, source_end;
	int target_start, target_end;
      PPCODE:
	if (cl_alg2cpos(attribute, alg_num, &source_start, &source_end, &target_start, &target_end)) {
	  EXTEND(sp, 4);  /* returns 4 scalar values */
	  PUSHs(sv_2mortal(newSViv(source_start)));
	  PUSHs(sv_2mortal(newSViv(source_end)));
	  PUSHs(sv_2mortal(newSViv(target_start)));
	  PUSHs(sv_2mortal(newSViv(target_end)));
	}	
	/* else return empty list */

int
call_dynamic_attribute(attribute, dcr, args, nr_args)
	Attribute *	attribute
	DynCallResult *	dcr
	DynCallResult *	args
	int	nr_args

int
nr_of_arguments(attribute)
	Attribute *	attribute

