#!/bin/env perl -w
###################################################################
###                                                             ###
###      File: Makefile.PL                                      ###
###   Version:                                                  ###
###    Author: Stefan Evert                                     ###
###   Purpose: Perl Makefile for module.                        ###
###   Created: Fri Dec 11 17:18:31 1998                         ###
###  Modified: Wed Jan  2 15:33:15 2002 (evert)                 ###
###                                                             ###
###################################################################
#
# History:
#


use ExtUtils::MakeMaker;
use FileHandle;


# clean up in libdir
@backups = glob "lib/*~";			# just to make sure there are no emacs backups around
foreach $file (@backups) {
  print "deleting $file ... \n";
  unlink $file;
}

WriteMakefile( 
	      NAME => "CQP",
	      VERSION_FROM => "lib/CQP.pm",
	      PREREQ_PM => {
			    'CWB' => 1.0,
			    }
	     );
